--- old/usr/src/uts/common/inet/ip/sadb.c	Wed Jul  9 13:48:02 2014
+++ new/usr/src/uts/common/inet/ip/sadb.c	Wed Jul  9 13:48:02 2014
@@ -21,6 +21,7 @@
 /*
  * Copyright 2010 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
+ * Copyright (c) 2012 Nexenta Systems, Inc. All rights reserved.
  */
 
 #include <sys/types.h>
@@ -72,10 +73,6 @@
  * routines.  They are linked in with the AH module.  Since AH has no chance
  * of falling under export control, it was safe to link it in there.
  */
-
-static mblk_t *sadb_extended_acquire(ipsec_selector_t *, ipsec_policy_t *,
-    ipsec_action_t *, boolean_t, uint32_t, uint32_t, sadb_sens_t *,
-    netstack_t *);
 static ipsa_t *sadb_torch_assoc(isaf_t *, ipsa_t *);
 static void sadb_destroy_acqlist(iacqf_t **, uint_t, boolean_t,
 			    netstack_t *);
@@ -83,6 +80,15 @@
 static mblk_t *sadb_sa2msg(ipsa_t *, sadb_msg_t *);
 static ts_label_t *sadb_label_from_sens(sadb_sens_t *, uint64_t *);
 static sadb_sens_t *sadb_make_sens_ext(ts_label_t *tsl, int *len);
+/* Args named here, as the booleans can be hard to distinguish */
+static mblk_t *sadb_construct_acqmsg(ipsacq_t *acqrec, ipsec_selector_t *sel,
+    ipsec_action_t *ap, ipsec_policy_t *pp, netstack_t *ns, sadb_sens_t *sens,
+    boolean_t need_esp, boolean_t tunnel_mode, boolean_t extended,
+    boolean_t with_prop);
+static uint8_t *sadb_construct_eprop(const ipsec_action_t *,
+    const ipsec_policy_t *, netstack_t *, const uint8_t *, const uint8_t *);
+static void sadb_insert_prop(sadb_prop_t *, const ipsec_action_t *,
+    netstack_t *, uint_t, boolean_t);
 
 static time_t sadb_add_time(time_t, uint64_t);
 static void lifetime_fuzz(ipsa_t *);
@@ -99,6 +105,13 @@
  */
 extern uint64_t ipsacq_maxpackets;
 
+/*
+ * Allocation size for sin_t/sin6_t in address extensions. We allocate IPv6
+ * because it's the larger of the two, and we roundup because the type isn't
+ * defined to guarantee 64-bit alignment.
+ */
+#define SADB_SOCKADDR_SIZE	(roundup(sizeof (sin6_t), sizeof (uint64_t)))
+
 #define	SET_EXPIRE(sa, delta, exp) {				\
 	if (((sa)->ipsa_ ## delta) != 0) {				\
 		(sa)->ipsa_ ## exp = sadb_add_time((sa)->ipsa_addtime,	\
@@ -118,7 +131,34 @@
 	}								\
 }
 
+/* Warning: watch for evaluation issues with complex args */
+#define INITIALIZE_SAMSG(samsg, type)		\
+	(samsg)->sadb_msg_version = PF_KEY_V2,	\
+	(samsg)->sadb_msg_type = (type),	\
+	(samsg)->sadb_msg_errno = 0,		\
+	(samsg)->sadb_msg_reserved = 0
 
+/* Warning: watch for evaluation issues with complex args */
+#define ERRNO_SAMSG(samsg, errno)				\
+	(samsg)->sadb_msg_len = SADB_8TO64(sizeof (*samsg)),	\
+	(samsg)->sadb_msg_errno = (errno),			\
+	(samsg)->sadb_x_msg_diagnostic = 0
+
+/*
+ * Warning: watch for evaluation issues with complex args. This is a rough,
+ * conservative calculation (e.g. combined mode encr algs can perform both
+ * encr/auth and ipsecconf drops auth algs in combinations). This is
+ * nevertheless reasonable, given that the kernel doesn't make or guarantee
+ * optimizations reducing the combination space.
+ */
+#define CALC_COMBS(limit, ipss, need_esp)		{	\
+	limit = (need_esp) ?					\
+	    (ipss)->ipsec_nalgs[IPSEC_ALG_AUTH] *		\
+	    (ipss)->ipsec_nalgs[IPSEC_ALG_ENCR]			\
+	    : (ipss)->ipsec_nalgs[IPSEC_ALG_AUTH];		\
+	ASSERT((limit) > 0);					\
+}
+
 /* wrap the macro so we can pass it as a function pointer */
 void
 sadb_sa_refrele(void *target)
@@ -975,24 +1015,32 @@
 }
 
 /*
- * Initialize a SADB address extension at the address specified by addrext.
- * Return a pointer to the end of the new address extension.
+ * Takes two uint8_t (bounds on buffer in which to construct extension) and an
+ * addr (address to write into extension) pointer, a uint16_t (type of address
+ * in extension), and af, port, proto, and prefix values (further extension
+ * content). Returns a byte-aligned pointer to the end of the extension, which
+ * is of variable length depending on the address family.
  */
 static uint8_t *
-sadb_make_addr_ext(uint8_t *start, uint8_t *end, uint16_t exttype,
+sadb_make_addr_ext(const uint8_t *start, const uint8_t *end, uint16_t exttype,
     sa_family_t af, uint32_t *addr, uint16_t port, uint8_t proto, int prefix)
 {
 	struct sockaddr_in *sin;
 	struct sockaddr_in6 *sin6;
-	uint8_t *cur = start;
+	uint8_t *cur = (uint8_t *)start;
 	int addrext_len;
-	int sin_len;
 	sadb_address_t *addrext	= (sadb_address_t *)cur;
 
-	if (cur == NULL)
-		return (NULL);
+	ASSERT(cur != NULL && end != NULL);
 
 	cur += sizeof (*addrext);
+	sin = (struct sockaddr_in *)cur;
+	sin6 = (struct sockaddr_in6 *)cur;
+	cur += (af == AF_INET) ? sizeof (*sin) : sizeof (*sin6);
+
+	addrext_len = roundup(cur - start, sizeof (uint64_t));
+	cur = (uint8_t *)start + addrext_len;
+
 	if (cur > end)
 		return (NULL);
 
@@ -1000,15 +1048,10 @@
 	addrext->sadb_address_prefixlen = prefix;
 	addrext->sadb_address_reserved = 0;
 	addrext->sadb_address_exttype = exttype;
+	addrext->sadb_address_len = SADB_8TO64(addrext_len);
 
 	switch (af) {
 	case AF_INET:
-		sin = (struct sockaddr_in *)cur;
-		sin_len = sizeof (*sin);
-		cur += sin_len;
-		if (cur > end)
-			return (NULL);
-
 		sin->sin_family = af;
 		bzero(sin->sin_zero, sizeof (sin->sin_zero));
 		sin->sin_port = port;
@@ -1015,12 +1058,6 @@
 		IPSA_COPY_ADDR(&sin->sin_addr, addr, af);
 		break;
 	case AF_INET6:
-		sin6 = (struct sockaddr_in6 *)cur;
-		sin_len = sizeof (*sin6);
-		cur += sin_len;
-		if (cur > end)
-			return (NULL);
-
 		bzero(sin6, sizeof (*sin6));
 		sin6->sin6_family = af;
 		sin6->sin6_port = port;
@@ -1028,27 +1065,147 @@
 		break;
 	}
 
-	addrext_len = roundup(cur - start, sizeof (uint64_t));
-	addrext->sadb_address_len = SADB_8TO64(addrext_len);
+	return (cur);
+}
 
-	cur = start + addrext_len;
-	if (cur > end)
-		cur = NULL;
+/*
+ * Takes ipsec_selector_t (address information used in forming addr
+ * extensions) and ipsec_policy_t (contains pointer to selector key used in
+ * tunnel mode) pointers, tunnel mode boolean, and creates address extensions
+ * inside message contents bounds checked by byte-aligned start and end
+ * pointers. Returns new value for cur pointer or NULL on failure.
+ * XXX TODO: Original packet contents go here.
+ */
+static uint8_t *
+sadb_sel_to_addrexts(const ipsec_selector_t *sel, const ipsec_policy_t *pp,
+    const ipsec_action_t *ap, const uint8_t *start, const uint8_t *end,
+    boolean_t tunnel_mode)
+{
+	uint8_t		proto, pfxlen, *cur = (uint8_t *)start;
+	ipsec_selkey_t	*ipsl;
+	sa_family_t	af;
+	uint16_t	lport, rport;
+	uint32_t	*saddrptr, *daddrptr;
 
+	if (tunnel_mode) {
+		/*
+		 * Form inner address extensions based NOT on the inner
+		 * selectors (i.e. the packet data), but on the policy's
+		 * selector key (i.e. the policy's selector information).
+		 *
+		 * NOTE:  The position of IPv4 and IPv6 addresses is the
+		 * same in ipsec_selkey_t (unless the compiler does very
+		 * strange things with unions, consult your local C language
+		 * lawyer for details).
+		 */
+		ASSERT(pp != NULL);
+
+		ipsl = &(pp->ipsp_sel->ipsl_key);
+		if (ipsl->ipsl_valid & IPSL_IPV4) {
+			af = AF_INET;
+			ASSERT(sel->ips_protocol == IPPROTO_ENCAP);
+			ASSERT(!(ipsl->ipsl_valid & IPSL_IPV6));
+		} else {
+			af = AF_INET6;
+			ASSERT(sel->ips_protocol == IPPROTO_IPV6);
+			ASSERT(ipsl->ipsl_valid & IPSL_IPV6);
+		}
+
+		if (ipsl->ipsl_valid & IPSL_LOCAL_ADDR) {
+			saddrptr = (uint32_t *)(&ipsl->ipsl_local);
+			pfxlen = ipsl->ipsl_local_pfxlen;
+		} else {
+			saddrptr = (uint32_t *)(&ipv6_all_zeros);
+			pfxlen = 0;
+		}
+		/* XXX What about ICMP type/code? */
+		lport = (ipsl->ipsl_valid & IPSL_LOCAL_PORT) ?
+		    ipsl->ipsl_lport : 0;
+		proto = (ipsl->ipsl_valid & IPSL_PROTOCOL) ?
+		    ipsl->ipsl_proto : 0;
+
+		cur = sadb_make_addr_ext(cur, end, SADB_X_EXT_ADDRESS_INNER_SRC,
+		    af, saddrptr, lport, proto, pfxlen);
+		if (cur == NULL)
+			goto done;
+
+		if (ipsl->ipsl_valid & IPSL_REMOTE_ADDR) {
+			daddrptr = (uint32_t *)(&ipsl->ipsl_remote);
+			pfxlen = ipsl->ipsl_remote_pfxlen;
+		} else {
+			daddrptr = (uint32_t *)(&ipv6_all_zeros);
+			pfxlen = 0;
+		}
+		/* XXX What about ICMP type/code? */
+		rport = (ipsl->ipsl_valid & IPSL_REMOTE_PORT) ?
+		    ipsl->ipsl_rport : 0;
+
+		cur = sadb_make_addr_ext(cur, end, SADB_X_EXT_ADDRESS_INNER_DST,
+		    af, daddrptr, rport, proto, pfxlen);
+		if (cur == NULL)
+			goto done;
+
+		/*
+		 * TODO - if we go to RFC 3408's dream of transport mode
+		 * IP-in-IP _with_ inner-packet address selectors, we'll need
+		 * to further distinguish tunnel mode here.  For now, having
+		 * inner addresses and/or ports is sufficient.
+		 *
+		 * Meanwhile, whack proto/ports to reflect IP-in-IP for the
+		 * outer addresses.
+		 */
+		proto = sel->ips_protocol;	/* Either _ENCAP or _IPV6 */
+		lport = rport = 0;
+	} else if ((ap != NULL) && (!ap->ipa_want_unique)) {
+		/* Not in tunnel mode, action doesn't want pop from pkt */
+		proto = 0;
+		lport = 0;
+		rport = 0;
+		if (pp != NULL) {
+			ipsl = &(pp->ipsp_sel->ipsl_key);
+			if (ipsl->ipsl_valid & IPSL_PROTOCOL)
+				proto = ipsl->ipsl_proto;
+			if (ipsl->ipsl_valid & IPSL_REMOTE_PORT)
+				rport = ipsl->ipsl_rport;
+			if (ipsl->ipsl_valid & IPSL_LOCAL_PORT)
+				lport = ipsl->ipsl_lport;
+		}
+	} else {
+		/* Not in tunnel mode, action wants pop from pkt */
+		proto = sel->ips_protocol;
+		lport = sel->ips_local_port;
+		rport = sel->ips_remote_port;
+	}
+
+	af = sel->ips_isv4 ? AF_INET : AF_INET6;
+
+	/*
+	 * NOTE:  The position of IPv4 and IPv6 addresses is the same
+	 * in ipsec_selector_t.
+	 */
+	cur = sadb_make_addr_ext(cur, end, SADB_EXT_ADDRESS_SRC, af,
+	    (uint32_t *)(&sel->ips_local_addr_v6), lport, proto, 0);
+	if (cur == NULL)
+		goto done;
+
+	cur = sadb_make_addr_ext(cur, end, SADB_EXT_ADDRESS_DST, af,
+	    (uint32_t *)(&sel->ips_remote_addr_v6), rport, proto, 0);
+done:
 	return (cur);
 }
 
 /*
- * Construct a key management cookie extension.
+ * Use byte aligned buffer defined by cur and end pointers to create a key
+ * management extension using kmc and kmp uint32_t parameters.
  */
-
 static uint8_t *
-sadb_make_kmc_ext(uint8_t *cur, uint8_t *end, uint32_t kmp, uint32_t kmc)
+sadb_make_kmc_ext(const uint8_t *start, const uint8_t *end,
+    uint32_t kmp, uint32_t kmc)
 {
-	sadb_x_kmc_t *kmcext = (sadb_x_kmc_t *)cur;
+	uint8_t		*cur = (uint8_t *)start;
+	sadb_x_kmc_t	*kmcext = (sadb_x_kmc_t *)cur;
 
-	if (cur == NULL)
-		return (NULL);
+	ASSERT(cur != NULL && end != NULL);
 
 	cur += sizeof (*kmcext);
 
@@ -3198,7 +3355,7 @@
 		newbie->ipsa_kcfauthkey.ck_length = newbie->ipsa_authkeybits;
 		newbie->ipsa_kcfauthkey.ck_data = newbie->ipsa_authkey;
 
-		mutex_enter(&ipss->ipsec_alg_lock);
+		rw_enter(&ipss->ipsec_alg_lock, RW_READER);
 		alg = ipss->ipsec_alglists[IPSEC_ALG_AUTH]
 		    [newbie->ipsa_auth_alg];
 		if (alg != NULL && ALG_VALID(alg)) {
@@ -3211,7 +3368,7 @@
 			newbie->ipsa_amech.cm_type = CRYPTO_MECHANISM_INVALID;
 		}
 		error = ipsec_create_ctx_tmpl(newbie, IPSEC_ALG_AUTH);
-		mutex_exit(&ipss->ipsec_alg_lock);
+		rw_exit(&ipss->ipsec_alg_lock);
 		if (error != 0) {
 			mutex_exit(&newbie->ipsa_lock);
 			/*
@@ -3228,7 +3385,7 @@
 	}
 
 	if (ekey != NULL) {
-		mutex_enter(&ipss->ipsec_alg_lock);
+		rw_enter(&ipss->ipsec_alg_lock, RW_READER);
 		async = async || (ipss->ipsec_algs_exec_mode[IPSEC_ALG_ENCR] ==
 		    IPSEC_ALGS_EXEC_ASYNC);
 		alg = ipss->ipsec_alglists[IPSEC_ALG_ENCR]
@@ -3261,7 +3418,7 @@
 		} else {
 			newbie->ipsa_emech.cm_type = CRYPTO_MECHANISM_INVALID;
 		}
-		mutex_exit(&ipss->ipsec_alg_lock);
+		rw_exit(&ipss->ipsec_alg_lock);
 
 		/*
 		 * The byte stream following the sadb_key_t is made up of:
@@ -3373,9 +3530,9 @@
 		newbie->ipsa_kcfencrkey.ck_length = newbie->ipsa_encrkeybits;
 		newbie->ipsa_kcfencrkey.ck_data = newbie->ipsa_encrkey;
 
-		mutex_enter(&ipss->ipsec_alg_lock);
+		rw_enter(&ipss->ipsec_alg_lock, RW_READER);
 		error = ipsec_create_ctx_tmpl(newbie, IPSEC_ALG_ENCR);
-		mutex_exit(&ipss->ipsec_alg_lock);
+		rw_exit(&ipss->ipsec_alg_lock);
 		if (error != 0) {
 			mutex_exit(&newbie->ipsa_lock);
 			/* See above for error explanation. */
@@ -3799,12 +3956,9 @@
 
 	samsg = (sadb_msg_t *)mp->b_wptr;
 	mp->b_wptr += sizeof (*samsg);
-	samsg->sadb_msg_version = PF_KEY_V2;
-	samsg->sadb_msg_type = SADB_EXPIRE;
-	samsg->sadb_msg_errno = 0;
+	INITIALIZE_SAMSG(samsg, SADB_EXPIRE);
 	samsg->sadb_msg_satype = assoc->ipsa_type;
 	samsg->sadb_msg_len = SADB_8TO64(alloclen);
-	samsg->sadb_msg_reserved = 0;
 	samsg->sadb_msg_seq = 0;
 	samsg->sadb_msg_pid = 0;
 
@@ -4096,7 +4250,7 @@
 
 /*
  * Called by a consumer protocol to do ther dirty work of reaping dead
- * Security Associations.
+ * Security Associations and outstanding acquire records.
  *
  * NOTE: sadb_age_assoc() marks expired SA's as DEAD but only removed
  * SA's that are already marked DEAD, so expired SA's are only reaped
@@ -4810,6 +4964,8 @@
 	sa_family_t fam;
 	uint32_t blank_address[4] = {0, 0, 0, 0};
 
+	ASSERT(MUTEX_HELD(&bucket->iacqf_lock));
+
 	if (isrc == NULL) {
 		ASSERT(idst == NULL);
 		isrc = idst = blank_address;
@@ -4843,56 +4999,61 @@
 }
 
 /*
- * For this mblk, insert a new acquire record.  Assume bucket contains addrs
- * of all of the same length.  Give up (and drop) if memory
- * cannot be allocated for a new one; otherwise, invoke callback to
- * send the acquire up..
+ * Take a pointers to mblk_t (packet for which we need to acquire an SA) and
+ * ip_xmit_attr_t (transmit attributes used to generate or retrieve acquire
+ * record) and two booleans need_ah and need_esp, one but not both of which
+ * must be true. Acquire records are stored in hash buckets, and we assume
+ * bucket contains addrs of all of the same length. If this is a new acquire
+ * record, we generate an acquire samsg to send to protocol keysock layer,
+ * which assumes ownership from there. If we run into problems along the way,
+ * we generate errors if possible and drop packets if need be. Before sending
+ * to keysock, we simply unlock the acquire record and let the ager deal with
+ * releasing locks and freeing resources.
  *
- * In cases where we need both AH and ESP, add the SA to the ESP ACQUIRE
- * list.  The ah_add_sa_finish() routines can look at the packet's attached
- * attributes and handle this case specially.
+ * This code is called by the IP stack when trying to send a packet for which
+ * all necessary SAs can't be found to include in ip_xmit_attr_t. Be aware of
+ * the following case: you need both ESP and AH and have SAs for neither. In
+ * that case both need_esp and need_ah are true, but we go with need_esp, as
+ * ESP will call us back for an AH acquire if it's successful and the AH SA
+ * still missing. It can also be that the packet needs both, but an SA already
+ * exists for one, in which case only the missing one will be flagged as
+ * needed, although the ipsec_action_t has want flags for both.
  */
 void
 sadb_acquire(mblk_t *datamp, ip_xmit_attr_t *ixa, boolean_t need_ah,
     boolean_t need_esp)
 {
-	mblk_t	*asyncmp;
+	mblk_t		*asyncmp, *regular, *extended, *prop_m, *eprop_m;
 	sadbp_t *spp;
 	sadb_t *sp;
 	ipsacq_t *newbie;
 	iacqf_t *bucket;
-	mblk_t *extended;
 	ipha_t *ipha = (ipha_t *)datamp->b_rptr;
 	ip6_t *ip6h = (ip6_t *)datamp->b_rptr;
-	uint32_t *src, *dst, *isrc, *idst;
+	uint32_t	seq, *src, *dst, *isrc, *idst;
 	ipsec_policy_t *pp = ixa->ixa_ipsec_policy;
 	ipsec_action_t *ap = ixa->ixa_ipsec_action;
 	sa_family_t af;
-	int hashoffset;
-	uint32_t seq;
+	int		hashoffset, sens_len;
 	uint64_t unique_id = 0;
+	uint_t		propsize, epropsize, combs_limit;
+	uint8_t		*start, *end;
+	sadb_msg_t	*samsg;
+	sadb_prop_t	*prop, *eprop;
 	ipsec_selector_t sel;
 	boolean_t tunnel_mode = (ixa->ixa_flags & IXAF_IPSEC_TUNNEL) != 0;
 	ts_label_t 	*tsl = NULL;
 	netstack_t	*ns = ixa->ixa_ipst->ips_netstack;
 	ipsec_stack_t	*ipss = ns->netstack_ipsec;
-	sadb_sens_t 	*sens = NULL;
-	int 		sens_len;
+	sadb_sens_t	*sens = NULL;
+	ipsecesp_stack_t *espstack = ns->netstack_ipsecesp;
+	ipsecah_stack_t	*ahstack = ns->netstack_ipsecah;
+	queue_t 	*q;
 
-	ASSERT((pp != NULL) || (ap != NULL));
+	ASSERT(need_ah || need_esp);
+	ASSERT((ap != NULL) || (pp != NULL));
 
-	ASSERT(need_ah != NULL || need_esp != NULL);
-
-	/* Assign sadb pointers */
-	if (need_esp) { /* ESP for AH+ESP */
-		ipsecesp_stack_t *espstack = ns->netstack_ipsecesp;
-
-		spp = &espstack->esp_sadb;
-	} else {
-		ipsecah_stack_t	*ahstack = ns->netstack_ipsecah;
-
-		spp = &ahstack->ah_sadb;
-	}
+	spp = need_esp ? &espstack->esp_sadb : &ahstack->ah_sadb;
 	sp = (ixa->ixa_flags & IXAF_IS_IPV4) ? &spp->s_v4 : &spp->s_v6;
 
 	if (is_system_labeled())
@@ -4900,7 +5061,6 @@
 
 	if (ap == NULL)
 		ap = pp->ipsp_act;
-
 	ASSERT(ap != NULL);
 
 	if (ap->ipa_act.ipa_apply.ipp_use_unique || tunnel_mode)
@@ -4913,7 +5073,6 @@
 	 * below the lowest point allowed in the kernel.  (In other words,
 	 * make sure the high bit on the sequence number is set.)
 	 */
-
 	seq = keysock_next_seq(ns) | IACQF_LOWEST_SEQ;
 
 	if (IPH_HDR_VERSION(ipha) == IP_VERSION) {
@@ -4920,6 +5079,7 @@
 		src = (uint32_t *)&ipha->ipha_src;
 		dst = (uint32_t *)&ipha->ipha_dst;
 		af = AF_INET;
+		ip6h = NULL;
 		hashoffset = OUTBOUND_HASH_V4(sp, ipha->ipha_dst);
 		ASSERT(ixa->ixa_flags & IXAF_IS_IPV4);
 	} else {
@@ -4927,6 +5087,7 @@
 		src = (uint32_t *)&ip6h->ip6_src;
 		dst = (uint32_t *)&ip6h->ip6_dst;
 		af = AF_INET6;
+		ipha = NULL;
 		hashoffset = OUTBOUND_HASH_V6(sp, ip6h->ip6_dst);
 		ASSERT(!(ixa->ixa_flags & IXAF_IS_IPV4));
 	}
@@ -4952,8 +5113,8 @@
 	}
 
 	/*
-	 * Check buckets to see if there is an existing entry.  If so,
-	 * grab it.  sadb_checkacquire locks newbie if found.
+	 * Check bucket for existing matching entry. If so, grab it. On match
+	 * sadb_checkacquire returns locked newbie.
 	 */
 	bucket = &(sp->sdb_acq[hashoffset]);
 	mutex_enter(&bucket->iacqf_lock);
@@ -4960,10 +5121,8 @@
 	newbie = sadb_checkacquire(bucket, ap, pp, src, dst, isrc, idst,
 	    unique_id, tsl);
 
+	/* If not found, initialize a new one and insert into chain. */
 	if (newbie == NULL) {
-		/*
-		 * Otherwise, allocate a new one.
-		 */
 		newbie = kmem_zalloc(sizeof (*newbie), KM_NOSLEEP);
 		if (newbie == NULL) {
 			mutex_exit(&bucket->iacqf_lock);
@@ -5000,27 +5159,22 @@
 	 * we might be able to dispense with acquire record locks entirely..
 	 * just use the bucket locks..
 	 */
-
 	mutex_exit(&bucket->iacqf_lock);
 
 	/*
 	 * This assert looks silly for now, but we may need to enter newbie's
-	 * mutex during a search.
+	 * mutex during a search. Confirms we got locked newbie from
+	 * sadb_checkacquire.
 	 */
 	ASSERT(MUTEX_HELD(&newbie->ipsacq_lock));
 
-	/*
-	 * Make the ip_xmit_attr_t into something we can queue.
-	 * If no memory it frees datamp.
-	 */
+	/* Make ip_xmit_attr_t into message we can queue, link packet data. */
 	asyncmp = ip_xmit_attr_to_mblk(ixa);
 	if (asyncmp != NULL)
 		linkb(asyncmp, datamp);
 
-	/* Queue up packet.  Use b_next. */
-
+	/* Bump appropriate discard stat & free datamp if allocation failed. */
 	if (asyncmp == NULL) {
-		/* Statistics for allocation failure */
 		if (ixa->ixa_flags & IXAF_IS_IPV4) {
 			BUMP_MIB(&ixa->ixa_ipst->ips_ip_mib,
 			    ipIfStatsOutDiscards);
@@ -5030,15 +5184,11 @@
 		}
 		ip_drop_output("No memory for asyncmp", datamp, NULL);
 		freemsg(datamp);
-	} else if (newbie->ipsacq_numpackets == 0) {
-		/* First one. */
+	} else if (newbie->ipsacq_numpackets == 0) { /* Pkt queue forms here. */
 		newbie->ipsacq_mp = asyncmp;
 		newbie->ipsacq_numpackets = 1;
 		newbie->ipsacq_expire = gethrestime_sec();
-		/*
-		 * Extended ACQUIRE with both AH+ESP will use ESP's timeout
-		 * value.
-		 */
+		/* Extended ACQUIRE with AH+ESP uses ESP's timeout */
 		newbie->ipsacq_expire += *spp->s_acquire_timeout;
 		newbie->ipsacq_seq = seq;
 		newbie->ipsacq_addrfam = af;
@@ -5062,17 +5212,17 @@
 		}
 		newbie->ipsacq_unique_id = unique_id;
 
-		if (ixa->ixa_tsl != NULL) {
-			label_hold(ixa->ixa_tsl);
-			newbie->ipsacq_tsl = ixa->ixa_tsl;
+		if (tsl != NULL) {
+			label_hold(tsl);
+			newbie->ipsacq_tsl = tsl;
 		}
-	} else {
-		/* Scan to the end of the list & insert. */
+	} else { /* Attempt to join packet queue as b_next. */
 		mblk_t *lastone = newbie->ipsacq_mp;
 
 		while (lastone->b_next != NULL)
 			lastone = lastone->b_next;
 		lastone->b_next = asyncmp;
+		/* Queue maxed: set counter to max, unchain, free & drop pkt */
 		if (newbie->ipsacq_numpackets++ == ipsacq_maxpackets) {
 			newbie->ipsacq_numpackets = ipsacq_maxpackets;
 			lastone = newbie->ipsacq_mp;
@@ -5079,12 +5229,11 @@
 			newbie->ipsacq_mp = lastone->b_next;
 			lastone->b_next = NULL;
 
-			/* Freeing the async message */
 			lastone = ip_xmit_attr_free_mblk(lastone);
 			ip_drop_packet(lastone, B_FALSE, NULL,
 			    DROPPER(ipss, ipds_sadb_acquire_toofull),
 			    &ipss->ipsec_sadb_dropper);
-		} else {
+		} else { /* Successfully queued */
 			IP_ACQUIRE_STAT(ipss, qhiwater,
 			    newbie->ipsacq_numpackets);
 		}
@@ -5100,21 +5249,58 @@
 	newbie->ipsacq_dstaddr = dst;
 
 	/*
-	 * If the acquire record has more than one queued packet, we've
-	 * already sent an ACQUIRE, and don't need to repeat ourself.
+	 * Sequence number mismatch or previously populated packet queue means
+	 * we retrieved an already-pending ACQUIRE record and needn't repeat
+	 * ourself. Unlock and return.
 	 */
-	if (newbie->ipsacq_seq != seq || newbie->ipsacq_numpackets > 1) {
-		/* I have an acquire outstanding already! */
-		mutex_exit(&newbie->ipsacq_lock);
-		return;
+	if (newbie->ipsacq_seq != seq || newbie->ipsacq_numpackets > 1)
+		goto unlock_acqrec;
+
+	/*
+	 * Even if we fail before sending to keysock, starting with a NULL
+	 * queue pointer, if gets this far, it counts as an acquire request.
+	 */
+	if (need_esp) {
+		ESP_BUMP_STAT(espstack, acquire_requests);
+		q = espstack->esp_pfkey_q;
+	} else {
+		AH_BUMP_STAT(ahstack, acquire_requests);
+		q = ahstack->ah_pfkey_q;
 	}
 
-	if (!keysock_extended_reg(ns))
-		goto punt_extended;
+	if (q == NULL)
+		goto unlock_acqrec;
+
+	/* Initializes keysock M_CTL message for regular acquire. */
+	regular = sadb_keysock_out(0);
+	if (regular == NULL)
+		goto unlock_acqrec;
+
 	/*
-	 * Construct an extended ACQUIRE.  There are logging
-	 * opportunities here in failure cases.
+	 * Check keysock stack to make sure we don't have extended register
+	 * pending. If not, have keysock initialize M_CTL msg for extended
+	 * acquire. If pending, set extended to NULL so we ignore it hereafter.
 	 */
+	if (keysock_extended_reg(ns)) {
+		extended = sadb_keysock_out(0);
+		if (extended == NULL)
+			goto bail_and_free_regular;
+	} else {
+		extended = NULL;
+	}
+
+	if (tsl != NULL) {
+		/*
+		 * XXX MLS correct condition here?
+		 * XXX MLS other credential attributes in acquire?
+		 * XXX malloc failure?  don't fall back to original?
+		 */
+		sens = sadb_make_sens_ext(tsl, &sens_len);
+
+		if (sens == NULL)
+			goto bail_extended;
+	}
+	/* re-initialize selector using ixa and ipha */
 	bzero(&sel, sizeof (sel));
 	sel.ips_isv4 = (ixa->ixa_flags & IXAF_IS_IPV4) != 0;
 	if (tunnel_mode) {
@@ -5136,45 +5322,96 @@
 		sel.ips_remote_addr_v6 = ip6h->ip6_dst;
 	}
 
-	extended = sadb_keysock_out(0);
-	if (extended == NULL)
-		goto punt_extended;
+	/* Tack message containing sadb_msg_t onto keysock regular M_CTL */
+	regular->b_cont = sadb_construct_acqmsg(newbie, &sel, ap, pp, ns, sens,
+	    need_esp, tunnel_mode, B_FALSE, B_FALSE); /* regular, no props */
+	/* We have to do this, no matter the result of previous call */
+	if (sens != NULL)
+		kmem_free(sens, sens_len);
 
-	if (ixa->ixa_tsl != NULL) {
-		/*
-		 * XXX MLS correct condition here?
-		 * XXX MLS other credential attributes in acquire?
-		 * XXX malloc failure?  don't fall back to original?
-		 */
-		sens = sadb_make_sens_ext(ixa->ixa_tsl, &sens_len);
+	if (regular->b_cont == NULL)
+		goto bail_extended;
 
-		if (sens == NULL) {
-			freeb(extended);
-			goto punt_extended;
-		}
+	/*
+	 * If there's no extended pending, duplicate regular samsg, tacking it
+	 * on as the b_cont of the keysock-generated extended M_CTL.
+	 */
+	if (extended != NULL) {
+		extended->b_cont = dupb(regular->b_cont);
+		if (extended->b_cont == NULL)
+			goto bail_extended;
 	}
 
-	extended->b_cont = sadb_extended_acquire(&sel, pp, ap, tunnel_mode,
-	    seq, 0, sens, ns);
+	rw_enter(&ipss->ipsec_alg_lock, RW_READER);
+	CALC_COMBS(combs_limit, ipss, need_esp);
+	propsize = sizeof (sadb_prop_t) + (combs_limit * sizeof (sadb_comb_t));
 
-	if (sens != NULL)
-		kmem_free(sens, sens_len);
+	if ((prop_m = allocb(propsize, BPRI_HI)) == NULL)
+		goto bail_and_unlock;
 
-	if (extended->b_cont == NULL) {
-		freeb(extended);
-		goto punt_extended;
+	if (extended != NULL) {
+		epropsize = sizeof (sadb_prop_t)
+		    + (combs_limit * sizeof (sadb_x_ecomb_t));
+		if ((eprop_m = allocb(epropsize, BPRI_HI)) == NULL)
+			goto bail_and_unlock;
 	}
 
-	/*
-	 * Send an ACQUIRE message (and possible an extended ACQUIRE) based on
-	 * this new record.  The send-acquire callback assumes that acqrec is
-	 * already locked.
-	 */
-	(*spp->s_acqfn)(newbie, extended, ns);
+	prop = (sadb_prop_t *)prop_m->b_rptr;
+	sadb_insert_prop(prop, ap, ns, combs_limit, need_esp);
+	if (prop == NULL) {
+		goto bail_and_unlock;
+	/* 0 length prop is error, mark regular samsg a dud, & freeb prop_m */
+	} else {
+		samsg = (sadb_msg_t *)regular->b_cont->b_rptr;
+
+		if (prop->sadb_prop_len == 0) {
+			ERRNO_SAMSG(samsg, ENOENT);
+			freeb(prop_m);
+		}
+		samsg->sadb_msg_len += prop->sadb_prop_len;
+		prop_m->b_wptr += SADB_64TO8(prop->sadb_prop_len);
+		regular->b_cont->b_cont = prop_m;
+	}
+
+	if (extended != NULL) {
+		start = (uint8_t *)eprop_m->b_rptr;
+		end = start + epropsize;
+		eprop =
+		    (sadb_prop_t *)sadb_construct_eprop(ap, pp, ns, start, end);
+		if (eprop == NULL)
+			goto bail_and_unlock;
+		/* If 0 ecombs, mark extended samsg a dud, and freeb eprop_m */
+		else {
+			samsg = (sadb_msg_t *)extended->b_cont->b_rptr;
+
+			if (eprop->sadb_x_prop_numecombs == 0) {
+				ERRNO_SAMSG(samsg, ENOENT);
+				freeb(eprop_m);
+			}
+			samsg->sadb_msg_len += eprop->sadb_prop_len;
+			eprop_m->b_wptr += SADB_64TO8(eprop->sadb_prop_len);
+			extended->b_cont->b_cont = eprop_m;
+		}
+	}
+
+	rw_exit(&ipss->ipsec_alg_lock);
+	mutex_exit(&newbie->ipsacq_lock);
+
+	if (extended != NULL)
+		putnext(q, extended);
+	putnext(q, regular);
 	return;
 
-punt_extended:
-	(*spp->s_acqfn)(newbie, NULL, ns);
+/* We used a lot of b_cont mblk chaining, so we need to use freemsg. */
+bail_and_unlock:
+	rw_exit(&ipss->ipsec_alg_lock);
+bail_extended:
+	if (extended != NULL)
+		freemsg(extended);
+bail_and_free_regular:
+	freemsg(regular);
+unlock_acqrec:
+	mutex_exit(&newbie->ipsacq_lock);
 }
 
 /*
@@ -5188,6 +5425,7 @@
 
 	ASSERT(MUTEX_HELD(acqrec->ipsacq_linklock));
 
+	/* XXX Should references be released before mutex is acquired? */
 	if (acqrec->ipsacq_policy != NULL) {
 		IPPOL_REFRELE(acqrec->ipsacq_policy);
 	}
@@ -5262,16 +5500,18 @@
  * framework's view of reality vs. IPsec's.  EF's wins, BTW.
  */
 static uint8_t *
-sadb_new_algdesc(uint8_t *start, uint8_t *limit,
+sadb_new_algdesc(const uint8_t *start, const uint8_t *end,
     sadb_x_ecomb_t *ecomb, uint8_t satype, uint8_t algtype,
     uint8_t alg, uint16_t minbits, uint16_t maxbits, ipsec_stack_t *ipss)
 {
-	uint8_t *cur = start;
+	uint8_t *cur = (uint8_t *)start;
 	ipsec_alginfo_t *algp;
 	sadb_x_algdesc_t *algdesc = (sadb_x_algdesc_t *)cur;
 
+	ASSERT(RW_READ_HELD(&ipss->ipsec_alg_lock));
+
 	cur += sizeof (*algdesc);
-	if (cur >= limit)
+	if (cur >= end)
 		return (NULL);
 
 	ecomb->sadb_x_ecomb_numalgs++;
@@ -5281,18 +5521,14 @@
 	 * a stronger policy, and when the framework loads a stronger version,
 	 * you can just keep plowing w/o rewhacking your SPD.
 	 */
-	mutex_enter(&ipss->ipsec_alg_lock);
 	algp = ipss->ipsec_alglists[(algtype == SADB_X_ALGTYPE_AUTH) ?
 	    IPSEC_ALG_AUTH : IPSEC_ALG_ENCR][alg];
-	if (algp == NULL) {
-		mutex_exit(&ipss->ipsec_alg_lock);
+	if (algp == NULL)
 		return (NULL);	/* Algorithm doesn't exist.  Fail gracefully. */
-	}
 	if (minbits < algp->alg_ef_minbits)
 		minbits = algp->alg_ef_minbits;
 	if (maxbits > algp->alg_ef_maxbits)
 		maxbits = algp->alg_ef_maxbits;
-	mutex_exit(&ipss->ipsec_alg_lock);
 
 	algdesc->sadb_x_algdesc_reserved = SADB_8TO1(algp->alg_saltlen);
 	algdesc->sadb_x_algdesc_satype = satype;
@@ -5305,28 +5541,29 @@
 }
 
 /*
- * Convert the given ipsec_action_t into an ecomb starting at *ecomb
- * which must fit before *limit
- *
- * return NULL if we ran out of room or a pointer to the end of the ecomb.
+ * Use buffer defined by byte-aligned pointers start and end to convert
+ * ipsec_action_t pointer act into an ecomb, using alg data hanging off of
+ * netstack_t pointer ns. Return NULL rather than overrun buffer, otherwise
+ * pointer to end of ecomb (which should be exact size of buffer).
  */
 static uint8_t *
-sadb_action_to_ecomb(uint8_t *start, uint8_t *limit, ipsec_action_t *act,
-    netstack_t *ns)
+sadb_action_to_ecomb(const uint8_t *start, const uint8_t *end,
+    const ipsec_action_t *act, netstack_t *ns)
 {
-	uint8_t *cur = start;
+	uint8_t *cur = (uint8_t *)start;
 	sadb_x_ecomb_t *ecomb = (sadb_x_ecomb_t *)cur;
 	ipsec_prot_t *ipp;
 	ipsec_stack_t *ipss = ns->netstack_ipsec;
 
+	ASSERT(RW_READ_HELD(&ipss->ipsec_alg_lock));
+	ASSERT(act->ipa_act.ipa_type == IPSEC_ACT_APPLY);
+
 	cur += sizeof (*ecomb);
-	if (cur >= limit)
+	if (cur >= end)
 		return (NULL);
 
-	ASSERT(act->ipa_act.ipa_type == IPSEC_ACT_APPLY);
+	ipp = &((ipsec_action_t *)act)->ipa_act.ipa_apply;
 
-	ipp = &act->ipa_act.ipa_apply;
-
 	ecomb->sadb_x_ecomb_numalgs = 0;
 	ecomb->sadb_x_ecomb_reserved = 0;
 	ecomb->sadb_x_ecomb_reserved2 = 0;
@@ -5350,7 +5587,7 @@
 	ecomb->sadb_x_ecomb_hard_usetime = 0;
 
 	if (ipp->ipp_use_ah) {
-		cur = sadb_new_algdesc(cur, limit, ecomb,
+		cur = sadb_new_algdesc(cur, end, ecomb,
 		    SADB_SATYPE_AH, SADB_X_ALGTYPE_AUTH, ipp->ipp_auth_alg,
 		    ipp->ipp_ah_minbits, ipp->ipp_ah_maxbits, ipss);
 		if (cur == NULL)
@@ -5360,7 +5597,7 @@
 
 	if (ipp->ipp_use_esp) {
 		if (ipp->ipp_use_espa) {
-			cur = sadb_new_algdesc(cur, limit, ecomb,
+			cur = sadb_new_algdesc(cur, end, ecomb,
 			    SADB_SATYPE_ESP, SADB_X_ALGTYPE_AUTH,
 			    ipp->ipp_esp_auth_alg,
 			    ipp->ipp_espa_minbits,
@@ -5369,7 +5606,7 @@
 				return (NULL);
 		}
 
-		cur = sadb_new_algdesc(cur, limit, ecomb,
+		cur = sadb_new_algdesc(cur, end, ecomb,
 		    SADB_SATYPE_ESP, SADB_X_ALGTYPE_CRYPT,
 		    ipp->ipp_encr_alg,
 		    ipp->ipp_espe_minbits,
